/*
** main.c
**
** Nokia 3310 Example Program
** Target: ATMEGA :: AVR-GCC
**
** Written by Tony Myatt - 2007
** Quantum Torque - www.quantumtorque.com
*/
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <avr/pgmspace.h>
#include <stdio.h>
#include <stdlib.h>
#include "lcd.h"
#define LUNG 20
int snk[LUNG][2];
int directie;
int lungime=3;
int directie=1;
int berry_x,berry_y,berry=0;
void snake_board()
{
	int i;
	for(i=0;i<80;i++)
	{
		snake_lcd_set_pixel(0,i);
		snake_lcd_set_pixel(63,i);
	}
	for(i=0;i<80;i++)
	{
		snake_lcd_set_pixel(i,0);
		snake_lcd_set_pixel(i,79);
	}
}
int GetButton()
{
  
	if ( ( PIND | 0b11111110 ) == 0b11111110 )
		return 1;
	
	if ( ( PIND | 0b11111101 ) == 0b11111101 )
		return 4;

	if ( ( PIND | 0b01111111 ) == 0b01111111 )
		return 2;

	if ( ( PIND | 0b11011111 ) == 0b11011111 )
		return 3;	
  return 0;
}
void snake_get_berry()
{
	berry_x=random()%77+1;
	berry_y=random()%62+1;
	berry=1;
}
void snake_print_berry()
{
	snake_lcd_set_pixel(berry_x,berry_y);
}
void snake_init()
{
	int i=0;
	for(i=0;i<LUNG;i++)
	{
		snk[i][0]=snk[i][1]=0;
		directie=2;
	}
	snk[0][0]=20;
	snk[0][1]=20;
	snk[1][0]=20;
	snk[1][1]=21;
	snk[2][0]=20;
	snk[2][1]=22;
}
void snake_delay(int coef)
{
	int i,j;
	for(i=0;i<10000;i++)
		for(j=0;j<10*coef;j++)
			lcd_goto_xy(1,1);
}
void snake_draw()
{
	int i=0;
	for(i=0;i<lungime;i++)
		snake_lcd_set_pixel(snk[i][0],snk[i][1]);
}
void snake_deplasare()
{
	int i,aux,ok=1;
	aux=GetButton();
	if (aux!=0 && aux!=5)
		directie=aux;
	if (directie==1 && snk[lungime-1][0]  ==berry_x && snk[lungime-1][1]+1==berry_y)
		ok=0;
	if (directie==2 && snk[lungime-1][0]+1==berry_x && snk[lungime-1][1]  ==berry_y)
		ok=0;
	if (directie==3 && snk[lungime-1][0]  ==berry_x && snk[lungime-1][1]-1==berry_y)
		ok=0;
	if (directie==4 && snk[lungime-1][0]-1==berry_x && snk[lungime-1][1]  ==berry_y)
		ok=0;
	if (ok)
	{
		for(i=0;i<lungime-1;i++)
		{
			snk[i][0]=snk[i+1][0];
			snk[i][1]=snk[i+1][1];
		}

		if (directie==1)
		{
			snk[lungime-1][1]+=1;
		}
		if (directie==2)
		{
			snk[lungime-1][0]+=1;
		}
		if (directie==3)
		{
			snk[lungime-1][1]-=1;	
		}
		if (directie==4)
		{
			snk[lungime-1][0]-=1;
		}
	}
	else
	{
		snk[lungime][0]=berry_x;
		snk[lungime][1]=berry_y;
		berry=0;
		lungime++;
	}
}
int snake_collision()
{
	int i=0;
	for (i=0;i<lungime-1;i++)
	{
		if (snk[lungime-1][0]==snk[i][0] && snk[lungime-1][1]==snk[i][1])
			return 0;
	}
	if (snk[lungime-1][0] == 0 || snk[lungime-1][1]==0 || snk[lungime-1][0] > 63 || snk[lungime-1][1] > 79 )
		return 0;
	return 1;
}
/* main -- Program starts here */
int main(void)
{	
	int i,j;
	// Setup LCD
	lcd_init();
	DDRD=0x00;
	PORTD=0xFF;

	// Print on first line
	lcd_clear();
	snake_board();
	snake_init();
	snake_draw();
	snake_lcd_draw();
	snake_delay(10);
	while(1)
	{
		snake_lcd_clear();
		if (berry==0)
			snake_get_berry();
		snake_print_berry();
		snake_board();
		snake_deplasare();
		snake_draw();
		snake_lcd_draw();
		if (snake_collision()==0)
		{
			snake_lcd_clear();
			snake_lcd_draw();
			lcd_str("YOU LOST");
			snake_delay(2);
			break;
		}
		if (lungime==20)
		{
			snake_lcd_clear();
			snake_lcd_draw();
			lcd_str("YOU WON");
			snake_delay(2);
			break;
		}
		snake_delay(2);
	};
	lcd_str("GAME DESIGNED");
	lcd_goto_xy(10,2);
	lcd_str("BY");
	lcd_goto_xy(7,3);
	lcd_str("STEFAN");

}
